﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace solution
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void RobotDied()
        {
            MessageBox.Show("You have died");
        }


        private void addCommand_Button_Click(object sender, EventArgs e)
        {
            if (this.availableBox_ListBox.SelectedItem == null)
                return;

            this.box2do_ListBox.Items.Add(this.availableBox_ListBox.SelectedItem);
            this.availableBox_ListBox.Items.Remove(this.availableBox_ListBox.SelectedItem);
        }

        private void removeCommand_Botton_Click(object sender, EventArgs e)
        {
            if (this.box2do_ListBox.SelectedItem == null)
                return;

            this.availableBox_ListBox.Items.Add(this.box2do_ListBox.SelectedItem);
            this.box2do_ListBox.Items.Remove(this.box2do_ListBox.SelectedItem);
        }

        private void vykonat_Button_Click(object sender, EventArgs e)
        {
            if (this.box2do_ListBox.Items.Count != 5)
            {
                MessageBox.Show("Musite vybrat presne 5 ukolu pro robota");
                return;
            }

            string commands2do = string.Empty;

            foreach (object item in this.box2do_ListBox.Items)
            {
                commands2do += ((CommandPair)item).Command;
            }

            MoveRob(commands2do);
        }

        private void novaHraToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (ConnectForm cf = new ConnectForm())
            {
                if (cf.ShowDialog() == DialogResult.OK)
                {
                    this.moves = new List<char>();
                    wc = new System.Net.WebClient();
                    this.server = cf.server;
                    ParseMap(wc.DownloadString(server + "start"));
                }
            }
        }


        private List<char> moves; // jake pohyby uz jsme racili udelat
        
        private long gameId; // cislo hry
        
        private string[] Map; // mapa
        
        public string AvailableMoves; // kam muze

        //wc a server
        private System.Net.WebClient wc;
        public string server=string.Empty;

        public Robotek MyRobot;



        //HACK: nebudeme prece delat porad novy separator, jsme slusni a setrime :]
        private char[] LineSep = new char[] { '\r', '\n' };

        //prisla nova mapa? cas znova spracovat
        public void ParseMap(string Response)
        {
            this.response.Text = Response;

            Response = Response.Replace("\r\n", "\n");
            Response = Response.Remove(Response.Length - 1);

            //rozdelime si to na radky
            string[] SplResp = Response.Split('\n'); // Spl means splitted


            //dostaneme cislo hry
            this.gameId = System.Convert.ToInt64(SplResp[0]); //vezmeme prvni radek a vytahneme z nej cislo, (a vse jako inline prasecinu :P)

            //odrezeme dostupne pohyby
            AvailableMoves = SplResp[SplResp.Length - 1]; // dostupne pohyby are at last line
            foreach (char ch in AvailableMoves)
            {
                this.availableBox_ListBox.Items.Add(new CommandPair(ch));
            }
            this.availableBox_ListBox.Refresh();

            //odrezeme pozici robota
            string[] pozice = (string[])(SplResp[SplResp.Length - 2].Split(' '));
            //nastavime robota
            MyRobot = new Robotek(
                System.Convert.ToInt32(pozice[0])-1,
                System.Convert.ToInt32(pozice[1])-1,
                Robotek.getOrientationFromString(pozice[2]));
            
            //prostredek vyrezat!
            var list = new List<string>(SplResp);
            list.RemoveAt(0); list.RemoveRange(list.Count-2,2);
            this.Map = list.ToArray();

            reDrawMap();
        }


        //hni se! a delej! a tam kam "command" rika!
        public string MoveRob(string commands)
        {
            //upravime prikazi, nebudeme preci bourat do zdi ci prejicdet poklad
            Robotek TestRobot = new Robotek(MyRobot.x,MyRobot.y,MyRobot.Orientation);
            string commandsCanBeDone = string.Empty;
            for (short x = 0; x < 5; x++)
            {
                //vykoname mu prikaz
                TestRobot.DoCommand(commands[x]);

                
                if (TestRobot.x>19 || TestRobot.y>19 || Map[TestRobot.x][TestRobot.y] == '#') //Awwww! Hole!
                {
                    RobotDied();
                    break;
                }
                
                /**
                 * overime jestli uz neni konec prikazovani
                 */
                //Wall
                if (Map[TestRobot.x][TestRobot.y] == 'X') //Jsme na zdi, pohyb dopredu konci
                {
                    // nutno posunout o krok z5
                    switch (TestRobot.Orientation)
                    {
                        case RobotOrientation.Top:
                            TestRobot.y++;
                            break;

                        case RobotOrientation.Bottom:
                            TestRobot.y--;
                            break;

                        case RobotOrientation.Left:
                            TestRobot.x++;
                            break;

                        case RobotOrientation.Right:
                            TestRobot.x--;
                            break;
                    }
                    if (commands[x] == 'Z' || commands[x] == 'z' || System.Convert.ToInt16(commands[x]) == 1) // pokud je to jenom dozadu nebo o jeden krok tak preskocime
                        continue;
                    else
                        commandsCanBeDone += (System.Convert.ToInt16(commands[x]) - 1).ToString();

                }
                
                //Is it treasure? Oh!
                //TODO: neprojizdet pokladem

                commandsCanBeDone += commands[x];
            }

            string response = wc.DownloadString(server+"?id="+this.gameId+"&pohyby="+commandsCanBeDone);
            if (response.Split(LineSep).Length == 23)
                ParseMap(response);
            else
                EndGame(response);
            return string.Empty; //TODO: ...
        }

        //vrati vsechny uz udelane pohyby
        public char[] getMoves()
        {
            return (char[])moves.ToArray().Clone();
        }


        private void EndGame(string response)
        {
            MessageBox.Show(response);
        }

        private void reDrawMap()
        {
            int top = 0;
            int left = 0;
            foreach (string line in this.Map)
            {
                foreach (char cell in line)
                {
                    switch (cell)
                    {
                        case 'X':
                            Wall w = new Wall();
                            w.Location = new Point(left, top);
                            left += 30;
                            panel1.Controls.Add(w);
                            break;
                        case '#':
                            Hole h = new Hole();
                            h.Location = new Point(left, top);
                            left += 30;
                            top += 30;
                            panel1.Controls.Add(h);
                            break;
                        default:
                            break;
                    }
                }
                top += 30;
                left = 0;
            }

            switch (MyRobot.Orientation)
            {
                case RobotOrientation.Top:
                    RobotC r = new RobotC();
                    r.Location = new Point(MyRobot.x * 30, MyRobot.y * 30);
                    panel1.Controls.Add(r);
                    break;
            }
        }

        private void ukoncitProgramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

    }
}
