﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace solution
{
    public class Robotek
    {
        public int x;
        public int y;
        public RobotOrientation Orientation;
        public Robotek(int newx, int newy,RobotOrientation neworientation)
        {
            this.x = newx;
            this.y = newy;
            this.Orientation = neworientation;
        }

        public void Go(short fields)
        {
            if (fields > 3)
                fields = 3;
            if (fields < -1)
                fields = -1;

            //now we gonna switch right way
            switch (Orientation)
            {
                case RobotOrientation.Top:
                    y += fields;
                    break;

                case RobotOrientation.Bottom:
                    y -= fields;
                    break;

                case RobotOrientation.Left:
                    x -= fields;
                    break;

                case RobotOrientation.Right:
                    x += fields;
                    break;

                default: //no exception there because we are switching enum
                    break;

            }
        }

        public void Left()
        {
            //now we gonna switch right way
            switch (Orientation)
            {
                case RobotOrientation.Top:
                    Orientation = RobotOrientation.Left;
                    break;

                case RobotOrientation.Bottom:
                    Orientation = RobotOrientation.Right;
                    break;

                case RobotOrientation.Left:
                    Orientation = RobotOrientation.Bottom;
                    break;

                case RobotOrientation.Right:
                    Orientation = RobotOrientation.Top;
                    break;

                default: //no exception there because we are switching enum
                    break;

            }
        }

        public void Right()
        {
            //now we gonna switch right way
            switch (Orientation)
            {
                case RobotOrientation.Top:
                    Orientation = RobotOrientation.Right;
                    break;

                case RobotOrientation.Bottom:
                    Orientation = RobotOrientation.Left;
                    break;

                case RobotOrientation.Left:
                    Orientation = RobotOrientation.Top;
                    break;

                case RobotOrientation.Right:
                    Orientation = RobotOrientation.Bottom;
                    break;

                default: //no exception there because we are switching enum
                    break;

            }
        }

        public void DoCommand(char command)
        {
            switch (command)
            {
                case '1':
                case '2':
                case '3':
                    Go(System.Convert.ToInt16(command));
                    break;

                case 'Z':
                case 'z':
                    Go(-1);
                    break;

                case 'L':
                case 'l':
                    Left();
                    break;

                case 'R':
                case 'r':
                    Right();
                    break;

                default:
                    throw new ArgumentException("Ja neznat argument:" + command);
            }

        }

        public static RobotOrientation getOrientationFromString(string str)
        {
            switch (str)
            {
                case "N":
                case "n":
                    return RobotOrientation.Top;


                case "L":
                case "l":
                    return RobotOrientation.Left;


                case "R":
                case "r":
                    return RobotOrientation.Right;


                case "D":
                case "d":
                    return RobotOrientation.Bottom;


                default:
                    throw new ArgumentException("Ja neznat pozice otoceni:" + str);

            }
        }

    }
}
