﻿using System;
using System.Collections.Generic;
using System.Text;

namespace solution
{
    public delegate void RobotIsDeadDelegate();
    public delegate void EndGameDelegate(string message);

    class nasmazaniGame
    {
        private List<char> moves; // jake pohyby uz jsme racili udelat
        
        private long gameId; // cislo hry
        
        private string[] Map; // mapa
        
        public string AvailableMoves; // kam muze

        //wc a server
        private System.Net.WebClient wc;
        public string server=string.Empty;

        public Robotek MyRobot;

        public RobotIsDeadDelegate RobotIsDead;
        public EndGameDelegate EndGame;

        public nasmazaniGame(string server)
        {
            this.moves = new List<char>();
            wc = new System.Net.WebClient();
            ParseMap(wc.DownloadString(server+"start"));
        }




        //HACK: nebudeme prece delat porad novy separator, jsme slusni a setrime :]
        private char[] LineSep = new char[] { '\r', '\n' };

        //prisla nova mapa? cas znova spracovat
        public void ParseMap(string Response)
        {

            //rozdelime si to na radky
            string[] SplResp = Response.Split(LineSep); // Spl means splitted

            //dostaneme cislo hry
            this.gameId = System.Convert.ToInt64(SplResp[0]); //vezmeme prvni radek a vytahneme z nej cislo, (a vse jako inline prasecinu :P)
                

            //odrezeme dostupne pohyby
            AvailableMoves = SplResp[SplResp.Length - 1]; // dostupne pohyby are at last line


            //odrezeme pozici robota
            string[] pozice = (string[])(SplResp[SplResp.Length - 2].Split(' '));
            //nastavime robota
            MyRobot = new Robotek(
                System.Convert.ToInt32(pozice[0])-1,
                System.Convert.ToInt32(pozice[1])-1,
                Robotek.getOrientationFromString(pozice[2]));
            
            //prostredek vyrezat!
            var list = new List<string>(SplResp);
            list.RemoveAt(0); list.RemoveRange(list.Count-2,2);
            this.Map = list.ToArray();
        }


        //hni se! a delej! a tam kam "command" rika!
        public string Move(string commands)
        {
            //upravime prikazi, nebudeme preci bourat do zdi ci prejicdet poklad
            Robotek TestRobot = new Robotek(MyRobot.x,MyRobot.y,MyRobot.Orientation);
            string commandsCanBeDone = string.Empty;
            for (short x = 0; x < 5; x++)
            {
                //vykoname mu prikaz
                TestRobot.DoCommand(commands[x]);

                /**
                 * overime jestli uz neni konec prikazovani
                 */
                //Wall
                if (Map[TestRobot.x][TestRobot.y] == 'X') //Jsme na zdi, pohyb dopredu konci
                {
                    // nutno posunout o krok z5
                    switch (TestRobot.Orientation)
                    {
                        case RobotOrientation.Top:
                            TestRobot.y++;
                            break;

                        case RobotOrientation.Bottom:
                            TestRobot.y--;
                            break;

                        case RobotOrientation.Left:
                            TestRobot.x++;
                            break;

                        case RobotOrientation.Right:
                            TestRobot.x--;
                            break;
                    }
                    if (commands[x] == 'Z' || commands[x] == 'z' || System.Convert.ToInt16(commands[x]) == 1) // pokud je to jenom dozadu nebo o jeden krok tak preskocime
                        continue;
                    else
                        commandsCanBeDone += (System.Convert.ToInt16(commands[x]) - 1).ToString();

                }

                if (Map[TestRobot.x][TestRobot.y] == '#') //Awwww! Hole!
                {
                    RobotIsDead();
                    break;
                }
                
                //Is it treasure? Oh!
                //TODO: neprojizdet pokladem

                commandsCanBeDone += commands[x];
            }

            string response = wc.DownloadString(server+"?id="+this.gameId+"&pohyby="+commandsCanBeDone);
            if (response.Split(LineSep).Length == 23)
                ParseMap(response);
            else
                EndGame(response);
            return string.Empty; //TODO: ...
        }

        //vrati vsechny uz udelane pohyby
        public char[] getMoves()
        {
            return (char[])moves.ToArray().Clone();
        }
    }
}
